authorEmail="andyhsstudent@gmail.com"
errorDetailsEnabled=true

do errorHandler=process()
	local curError=""
	local line=0
	local recovery=nil
	
	local dispHelp=D2Editor.newRichText()
	
	function errorHandler:setError(l, e)
		curError=e
		line=l
	end
	
	function errorHandler:Open()
		lockTopProcess=true
		dispHelp:setVisible(false)
		dispHelp:setText("Here is the technical info:\n"..curError, 1)
		dispHelp:move(0, 60)
		dispHelp:setBorder(5)
		dispHelp:setBorderColor(0xFF0000)
		dispHelp:setReadOnly(true)
		dispHelp:resize(dispX, 85)
		dispHelp:setVisible(true)
		disp:invalidate()
	end
	
	function errorHandler:Close()
		dispHelp:setFocus(false)
		dispHelp:setVisible(false)
		unLockProcesses()
		if recovery~=nil then
			recovery()
		end
	end
	
	function errorHandler:paint(gc)
		gc:setColorRGB(0x0000FF)
		gc:fillRect(0,0,dispX,dispY)
		gc:setColorRGB(0x000000)
		gc:setFont("serif", "r", 12)
		gc:drawString("Oops. Something happened :(", 0, 0)
		gc:drawString("Press enter to go back", 0, gc:getStringHeight("Oops. Something happened :("))
		gc:drawString("or escape to go to main menu", 0, 2*gc:getStringHeight("Oops. Something happened :("))
		gc:setFont("serif", "r", 12)
		gc:drawString("Send the error message to:" , 0, 150)
		gc:drawString(authorEmail , 0, 150+gc:getStringHeight("Send the error message to:"))
	end
	
	function errorHandler:enterKey()
		PullProcess()
	end
	
	function errorHandler:escapeKey()
		PullProcess()
		while #processes>1 do
			PullProcess()
		end
		collectgarbage()
	end
	
	function errorHandler:setRecovery(func)
		recovery=func
	end
end

errorHandler:setRecovery(procRecovery)

function handleError(l, e)
	if errorDetailsEnabled then
		errorHandler:setError(l, e)
		PushProcess(errorHandler)
	end
end

platform.registerErrorHandler(function(l,e,stack,locals)
	handleError(l, e)
	return true
end)